#ifndef	___SOUND_H___
#define	___SOUND_H___

#include "common.h"

#include <SLES/OpenSLES.h>
#include <SLES/OpenSLES_Android.h>


namespace sys
{

/************************
    サウンドプレイヤー
 ************************/
class SoundPlayer
{
public :

	static SLObjectItf	engineObject;					// エンジンオブジェクト
	static SLEngineItf	engineEngine;					// インタフェース
	static float		master_volume;					// マスター音量

	static void		init_engine(void);					// 初期化
	static void		quit_engine(void);					// 終了
	static Bool		set_master_volume(float);			// マスター音量設定


private :

	SLObjectItf						outputMixObject;			// 出力オブジェクト
	SLObjectItf						bqPlayerObject;				// プレイヤーオブジェクト
	SLPlayItf						bqPlayerPlay;				// インタフェース
	SLAndroidSimpleBufferQueueItf	bqPlayerBufferQueue;		// バッファキューインタフェース
	SLVolumeItf						bqPlayerVolume;				// 音量インタフェース

	int		state;					// 状態
	float	volume;					// 音量

	char*	sound_data;				// サウンドデータ
	u32		sound_size;				// サウンドデータサイズ
	int		sound_loop;				// ループカウンタ

public :

// 状態
enum
{
	STOPPED,			// 停止中
	PREPARED,			// 準備
	PLAYING,			// 再生中
	PAUSED,				// 一時停止
};


		SoundPlayer(void);				// コンストラクタ
		~SoundPlayer();					// デストラクタ
	void	play(const void*, u32, int _loop = 1, float _vol = 1.0f);		// 再生
	void	play(void);
	void	prepare(const void*, u32, int _loop = 1, float _vol = 1.0f);	// 再生準備
	void	stop(void);														// 停止
	void	set_volume(float);												// 音量設定
	void	set_volume(void);
	void	pause(void);													// 一時停止
	void	resume(void);													// 再開
	int		get_state(void)													// 状態取得
			{
				return	state;
			}

	void	callback_wav(void);						// 再生コールバック
};

}

#endif
/********************* End of File ********************************/
